global convolucion_gradiente_asm

section .data
	mascara_3_primer_elemento:  dd -1, 0, 0, 0
	mascara_3_segundo_elemento: dd 0, -1, 0, 0
	mascara_3_tercer_elemento:  dd 0, 0, -1, 0
	mascara_3_cuarto_elemento:  dd 0, 0, 0, -1

section .text

convolucion_gradiente_asm:
	push rbp
	mov rbp, rsp
	sub rsp, 24
	push rbx
	push r12
	push r13
	push r14
	push r15


	; rdi = puntero a la imagen (bytes)
	; rsi = i
	; rdx  = j
	; rcx = step
	; r8 = kernel (puntero a int)
	; r9 = dst (puntero a int)


	push rsi


	sub rsi, 1
	sub rdx, 1
	push rdx

; rax = rcx * rsi + rdi + rdx
	mov rax, rcx
	mul rsi
	add rax, rdi

	pop rdx

	add rax, rdx
	
	; Levanto las 3 lineas de la imagen
	movdqu xmm2, [rax]

	add rax, rcx
	movdqu xmm3, [rax]

	add rax, rcx
	movdqu xmm4, [rax]

	pxor xmm8, xmm8 ; Limpio el registro xmm8
	pxor xmm10, xmm10 ; Limpio el registro xmm10 (va a ser el xmm del resultado a casa paso)
	pxor xmm11, xmm11 ; Limpio el registro xmm11 (va a ser el xmm del resultado final)

	; Convierto a words (16 bits)
	punpcklbw xmm2, xmm8
	punpcklbw xmm3, xmm8
	punpcklbw xmm4, xmm8

	; Levanto el kernel
	movdqu xmm5, [r8]
	movdqu xmm6, [r8+16]
	movdqu xmm7, [r8+32]

; Ahora proceso el byte de la posicion (i,j)
; Primera linea
	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm2
	; Convierto a enteros de 32 bits
	punpcklwd xmm2, xmm8

	pmulld xmm2, xmm5

	phaddd xmm2, xmm2
	phaddd xmm2, xmm2

	paddd xmm10, xmm2
	; Recupero el xmm2
	movdqa xmm2, xmm0

; Segunda linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm3
	; Convierto a enteros de 32 bits
	punpcklwd xmm3, xmm8

	pmulld xmm3, xmm6

	phaddd xmm3, xmm3
	phaddd xmm3, xmm3

	paddd xmm10, xmm3
	; Recupero el xmm3
	movdqa xmm3, xmm0


; Tercera linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm4
	; Convierto a enteros de 32 bits
	punpcklwd xmm4, xmm8

	pmulld xmm4, xmm7

	phaddd xmm4, xmm4
	phaddd xmm4, xmm4

	paddd xmm10, xmm4
	; Recupero el xmm4
	movdqa xmm4, xmm0

	movdqu xmm13, [mascara_3_primer_elemento]
	pand xmm10, xmm13
	paddd xmm11, xmm10

; Hasta aca para procesar el byte en la posicion (i,j)

	pxor xmm10, xmm10 ; Limpio el registro xmm10 (va a ser el xmm del resultado a casa paso)

; Ahora proceso el byte de la posicion (i,j+1)
; Shifteo a la derecha los registros xmm2, xmm3 y xmm4 en 2 bytes, y luego repito el proceso
	psrldq xmm2, 2
	psrldq xmm3, 2
	psrldq xmm4, 2


; Primera linea
	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm2
	; Convierto a enteros de 32 bits
	punpcklwd xmm2, xmm8

	pmulld xmm2, xmm5

	phaddd xmm2, xmm2
	phaddd xmm2, xmm2

	paddd xmm10, xmm2
	; Recupero el xmm2
	movdqa xmm2, xmm0

; Segunda linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm3
	; Convierto a enteros de 32 bits
	punpcklwd xmm3, xmm8

	pmulld xmm3, xmm6

	phaddd xmm3, xmm3
	phaddd xmm3, xmm3

	paddd xmm10, xmm3
	; Recupero el xmm3
	movdqa xmm3, xmm0


; Tercera linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm4
	; Convierto a enteros de 32 bits
	punpcklwd xmm4, xmm8

	pmulld xmm4, xmm7

	phaddd xmm4, xmm4
	phaddd xmm4, xmm4

	paddd xmm10, xmm4
	; Recupero el xmm4
	movdqa xmm4, xmm0

	movdqu xmm13, [mascara_3_segundo_elemento]
	pand xmm10, xmm13
	paddd xmm11, xmm10

; Hasta aca para procesar el byte en la posicion (i,j+1)

	pxor xmm10, xmm10 ; Limpio el registro xmm10 (va a ser el xmm del resultado a casa paso)

; Ahora proceso el byte de la posicion (i,j+2)
; Shifteo a la derecha los registros xmm2, xmm3 y xmm4 en 2 bytes, y luego repito el proceso
	psrldq xmm2, 2
	psrldq xmm3, 2
	psrldq xmm4, 2


; Primera linea
	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm2
	; Convierto a enteros de 32 bits
	punpcklwd xmm2, xmm8

	pmulld xmm2, xmm5

	phaddd xmm2, xmm2
	phaddd xmm2, xmm2

	paddd xmm10, xmm2
	; Recupero el xmm2
	movdqa xmm2, xmm0

; Segunda linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm3
	; Convierto a enteros de 32 bits
	punpcklwd xmm3, xmm8

	pmulld xmm3, xmm6

	phaddd xmm3, xmm3
	phaddd xmm3, xmm3

	paddd xmm10, xmm3
	; Recupero el xmm3
	movdqa xmm3, xmm0


; Tercera linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm4
	; Convierto a enteros de 32 bits
	punpcklwd xmm4, xmm8

	pmulld xmm4, xmm7

	phaddd xmm4, xmm4
	phaddd xmm4, xmm4

	paddd xmm10, xmm4
	; Recupero el xmm4
	movdqa xmm4, xmm0

	movdqu xmm13, [mascara_3_tercer_elemento]
	pand xmm10, xmm13
	paddd xmm11, xmm10

; Hasta aca para procesar el byte en la posicion (i,j+2)


	pxor xmm10, xmm10 ; Limpio el registro xmm10 (va a ser el xmm del resultado a casa paso)


; Ahora proceso el byte de la posicion (i,j+3)
; Shifteo a la derecha los registros xmm2, xmm3 y xmm4 en 2 bytes, y luego repito el proceso
	psrldq xmm2, 2
	psrldq xmm3, 2
	psrldq xmm4, 2


; Primera linea
	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm2
	; Convierto a enteros de 32 bits
	punpcklwd xmm2, xmm8

	pmulld xmm2, xmm5

	phaddd xmm2, xmm2
	phaddd xmm2, xmm2

	paddd xmm10, xmm2
	; Recupero el xmm2
	movdqa xmm2, xmm0

; Segunda linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm3
	; Convierto a enteros de 32 bits
	punpcklwd xmm3, xmm8

	pmulld xmm3, xmm6

	phaddd xmm3, xmm3
	phaddd xmm3, xmm3

	paddd xmm10, xmm3
	; Recupero el xmm3
	movdqa xmm3, xmm0


; Tercera linea

	; Me guardo una copia en un registro auxiliar
	movdqa xmm0, xmm4
	; Convierto a enteros de 32 bits
	punpcklwd xmm4, xmm8

	pmulld xmm4, xmm7

	phaddd xmm4, xmm4
	phaddd xmm4, xmm4

	paddd xmm10, xmm4
	; Recupero el xmm4
	movdqa xmm4, xmm0

	movdqu xmm13, [mascara_3_cuarto_elemento]
	pand xmm10, xmm13
	paddd xmm11, xmm10

; Hasta aca para procesar el byte en la posicion (i,j+3)


	movdqu [r9], xmm11



; Devuelvo la pila a su estado original
	pop rsi

	pop r15
	pop r14
	pop r13
	pop r12
	pop rbx
	
	add rsp, 24

	pop rbp


	ret