global procesar_pixeles
global convolucion_suavizado_asm

section .data
	kernel_5_1_1: dd 2, 4, 5, 4
	kernel_5_1_2: dd 2, 0, 0, 0
	kernel_5_2_1: dd 4, 9,12, 9
	kernel_5_2_2: dd 4, 0, 0, 0
	kernel_5_3_1: dd 5,12,15,12
	kernel_5_3_2: dd 5, 0, 0, 0
	kernel_suma: dd 159, 159, 159, 159

	mascara_primer_elemento:  dd -1, 0, 0, 0
	mascara_segundo_elemento: dd 0, -1, 0, 0
	mascara_tercer_elemento:  dd 0, 0, -1, 0
	mascara_cuarto_elemento:  dd 0, 0, 0, -1




section .text

procesar_pixeles:
	;input:
	;		- img src			-rdi
	;		- uchar* destino	-rsi
	;		- int i 			-rdx
	;		- int j 			-rcx
	;		- int step 			-r8
	;		- int alto 			-r9
	;	(El alto y el ancho no son necesarios. Que el i y el j esten dentro de los bounds los chequeo antes de hacer la llamada)




	push rbp
	mov rbp, rsp
	sub rsp, 24
	push rbx
	push r12
	push r13
	push r14
	push r15

	mov r15, 4

; Inicio de la logica

; Controlo que los valores de i y j esten dentro de la caja en donde me aseguro que no este levantando memoria fuera de la imagen


; Chequeo el valor de i
	cmp rdx, 2
	jge fin_chequeo_i_arriba

	mov rdx, 2

fin_chequeo_i_arriba:

	sub r9, 3
	cmp rdx, r9
	jle fin_chequeo_i_abajo

	mov rdx, r9

fin_chequeo_i_abajo:


; Chequeo el valor de j
	cmp rcx, 2
	jge fin_chequeo_j_izquierda

	mov rcx, 2

fin_chequeo_j_izquierda:
	
	sub r8, 17
	cmp rcx, r8
	jle fin_chequeo_j_derecha

	mov rcx, r8

fin_chequeo_j_derecha:

	add r8, 17

	push rdx
	push rcx

	mov r11, rsi
	mov r12, rdx
	mov r13, rcx
	mov r14, r8


	sub rdx, 2
	sub rcx, 2

	pxor xmm8, xmm8
	pxor xmm15, xmm15
; rax = rdx*r8 + rdi + rcx
	mov rax, rdx
	mul r8
	add rax, rdi
	add rax, rcx


	pop rcx
	pop rdx


; Levanto el kernel de a partes
	movdqu xmm6, [kernel_5_1_1]
	movdqu xmm7, [kernel_5_1_2]
	movdqu xmm9, [kernel_5_2_1]
	movdqu xmm10, [kernel_5_2_2]
	movdqu xmm11, [kernel_5_3_1]
	movdqu xmm12, [kernel_5_3_2]



; Me traigo 16 bytes de la fila i-2, empezando desde j-2 hasta j+14
	movdqu xmm1, [rax]
	; Tomo solo los primeros 8 bytes, y las transformo a words
	punpcklbw xmm1, xmm8

	; Me guardo una copia
	movdqa xmm0, xmm1


	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm1, xmm8
	
	; Multiplico
	pmullw xmm1, xmm6
	paddd xmm15, xmm1
	; Recupero el valor inicial de xmm1
	movdqa xmm1, xmm0

	; Me quedo con la parte alta de xmm1, y lo transformo a double word
	punpckhwd xmm1, xmm8
	
	pmullw xmm1, xmm7
	paddd xmm15, xmm1
	; Vuelvo a recuperar el valor de xmm1
	movdqa xmm1, xmm0

; Me traigo 16 bytes de la fila i-1, empezando desde j-2 hasta j+14
	add rax, r8
	
	movdqu xmm2, [rax]
	; Tomo solo los primeros 8 bytes, y las transformo a words
	punpcklbw xmm2, xmm8

	; Me guardo una copia
	movdqa xmm0, xmm2

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm2, xmm8
	
	; Multiplico
	pmullw xmm2, xmm9
	paddd xmm15, xmm2
	; Recupero el valor inicial de xmm1
	movdqa xmm2, xmm0

	; Me quedo con la parte alta de xmm2, y lo transformo a double word
	punpckhwd xmm2, xmm8
	
	pmullw xmm2, xmm10
	paddd xmm15, xmm2
	; Vuelvo a recuperar el valor de xmm2
	movdqa xmm2, xmm0

; Me traigo 16 bytes de la fila i, empezando desde j-2 hasta j+14
	add rax, r8
	
	movdqu xmm3, [rax]
	; Tomo solo los primeros 8 bytes, y las transformo a words
	punpcklbw xmm3, xmm8

	; Me guardo una copia
	movdqa xmm0, xmm3

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm3, xmm8
	
	; Multiplico
	pmullw xmm3, xmm11
	paddd xmm15, xmm3
	; Recupero el valor inicial de xmm1
	movdqa xmm3, xmm0

	; Me quedo con la parte alta de xmm3, y lo transformo a double word
	punpckhwd xmm3, xmm8
	
	pmullw xmm3, xmm12
	paddd xmm15, xmm3
	; Vuelvo a recuperar el valor de xmm3
	movdqa xmm3, xmm0

; Me traigo 16 bytes de la fila i+1, empezando desde j-2 hasta j+14
	add rax, r8
	
	movdqu xmm4, [rax]
	; Tomo solo los primeros 8 bytes, y las transformo a words
	punpcklbw xmm4, xmm8

	; Me guardo una copia
	movdqa xmm0, xmm4

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm4, xmm8

	; Multiplico
	pmullw xmm4, xmm9
	paddd xmm15, xmm4
	; Recupero el valor inicial de xmm1
	movdqa xmm4, xmm0

	; Me quedo con la parte alta de xmm4, y lo transformo a double word
	punpckhwd xmm4, xmm8
	
	pmullw xmm4, xmm10
	paddd xmm15, xmm4
	; Vuelvo a recuperar el valor de xmm4
	movdqa xmm4, xmm0

; Me traigo 16 bytes de la fila i+2, empezando desde j-2 hasta j+14
	add rax, r8
	
	movdqu xmm5, [rax]
	; Tomo solo los primeros 8 bytes, y las transformo a words
	punpcklbw xmm5, xmm8

	; Me guardo una copia
	movdqa xmm0, xmm5

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm5, xmm8
	
	; Multiplico
	pmullw xmm5, xmm6
	paddd xmm15, xmm5
	; Recupero el valor inicial de xmm1
	movdqa xmm5, xmm0

	; Me quedo con la parte alta de xmm5, y lo transformo a double word
	punpckhwd xmm5, xmm8

	pmullw xmm5, xmm7
	paddd xmm15, xmm5
	; Vuelvo a recuperar el valor de xmm5
	movdqa xmm5, xmm0

; En teoria, en xmm15 tengo:
; bits[0:31] -> img[i-2][j-2] * ker[0][0] + img[i-1][j-2] * ker[1][0] + img[i][j-2] * ker[2][0] + img[i+1][j-2] * ker[3][0] + img[i+2][j-2] * ker[4][0] + img[i-2][j+2] * ker[0][4] + img[i-1][j+2] * ker[1][4] + img[i][j+2] * ker[2][4] + img[i+1][j+2] * ker[3][4] + img[i+2][j+2] * ker[4][4] = part_1
; bits[32:63] -> img[i-2][j-1] * ker[0][1] + img[i-1][j-1] * ker[1][1] + img[i][j-1] * ker[2][1] + img[i+1][j-1] * ker[3][1] + img[i+2][j-1] * ker[4][1] = part_2
; bits[64:95] -> img[i-2][j] * ker[0][2] + img[i-1][j] * ker[1][2] + img[i][j] * ker[2][2] + img[i+1][j] * ker[3][2] + img[i+2][j] * ker[4][2] = part_3
; bits[96:127] -> img[i-2][j+1] * ker[0][3] + img[i-1][j+1] * ker[1][3] + img[i][j+1] * ker[2][3] + img[i+1][j+1] * ker[3][3] + img[i+2][j+1] * ker[4][3] = part_4
; Necesito hacer una suma horizontal

	phaddd xmm15, xmm15
	; [0:31] = part_1 + part_2
	; [32:63] = part_3 + part_4

	phaddd xmm15, xmm15
	; [0:31] = part_1 + part_2 + part_3 + part_4

	movq rax, xmm15
	movdqu xmm13, [mascara_primer_elemento]
	pand xmm15, xmm13
;	pand xmm15, [mascara_primer_elemento]


; Todo esto para calcular el kernel para 1 punto (i,j)



;; Intento procesar el punto (i, j+1)
	pxor xmm14, xmm14
	

	; Tomo los 4 bytes mas bajos, y los transformo a double words

	; Lo shifteo a la izquierda 2 bytes
	psrldq xmm1, 2
	movdqa xmm0, xmm1

	punpcklwd xmm1, xmm8
	
	; Multiplico
	pmullw xmm1, xmm6
	paddd xmm14, xmm1
	; Recupero el valor inicial de xmm1
	movdqa xmm1, xmm0

	; Me quedo con la parte alta de xmm1, y lo transformo a double word
	punpckhwd xmm1, xmm8
	
	pmullw xmm1, xmm7
	paddd xmm14, xmm1
	; Vuelvo a recuperar el valor de xmm1
	movdqa xmm1, xmm0



; Me traigo 16 bytes de la fila i-1, empezando desde j-2 hasta j+14

	psrldq xmm2, 2
	movdqa xmm0, xmm2

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm2, xmm8
	
	; Multiplico
	pmullw xmm2, xmm9
	paddd xmm14, xmm2
	; Recupero el valor inicial de xmm1
	movdqa xmm2, xmm0

	; Me quedo con la parte alta de xmm2, y lo transformo a double word
	punpckhwd xmm2, xmm8

	pmullw xmm2, xmm10
	paddd xmm14, xmm2
	; Vuelvo a recuperar el valor de xmm2
	movdqa xmm2, xmm0

; Me traigo 16 bytes de la fila i, empezando desde j-2 hasta j+14
	
	psrldq xmm3, 2
	movdqa xmm0, xmm3

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm3, xmm8

	; Multiplico
	pmullw xmm3, xmm11
	paddd xmm14, xmm3
	; Recupero el valor inicial de xmm1
	movdqa xmm3, xmm0

	; Me quedo con la parte alta de xmm3, y lo transformo a double word
	punpckhwd xmm3, xmm8

	pmullw xmm3, xmm12
	paddd xmm14, xmm3
	; Vuelvo a recuperar el valor de xmm3
	movdqa xmm3, xmm0

; Me traigo 16 bytes de la fila i+1, empezando desde j-2 hasta j+14
	psrldq xmm4, 2
	movdqa xmm0, xmm4

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm4, xmm8

	; Multiplico
	pmullw xmm4, xmm9
	paddd xmm14, xmm4
	; Recupero el valor inicial de xmm1
	movdqa xmm4, xmm0

	; Me quedo con la parte alta de xmm4, y lo transformo a double word
	punpckhwd xmm4, xmm8

	pmullw xmm4, xmm10
	paddd xmm14, xmm4
	; Vuelvo a recuperar el valor de xmm4
	movdqa xmm4, xmm0

; Me traigo 16 bytes de la fila i+2, empezando desde j-2 hasta j+14
	psrldq xmm5, 2
	movdqa xmm0, xmm5

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm5, xmm8
	
	; Multiplico
	pmullw xmm5, xmm6
	paddd xmm14, xmm5
	; Recupero el valor inicial de xmm1
	movdqa xmm5, xmm0

	; Me quedo con la parte alta de xmm5, y lo transformo a double word
	punpckhwd xmm5, xmm8

	pmullw xmm5, xmm7
	paddd xmm14, xmm5
	; Vuelvo a recuperar el valor de xmm5
	movdqa xmm5, xmm0


	phaddd xmm14, xmm14
	; [0:31] = part_1 + part_2
	; [32:63] = part_3 + part_4

	phaddd xmm14, xmm14
	; [0:31] = part_1 + part_2 + part_3 + part_4


; Todo esto para calcular el kernel para 1 punto (i,j+1)

	movdqu xmm13, [mascara_segundo_elemento]
	pand xmm14, xmm13
;	pand xmm14, [mascara_segundo_elemento]

	paddd xmm15, xmm14



;; Intento procesar el punto (i, j+2)
	pxor xmm14, xmm14


	; Tomo los 4 bytes mas bajos, y los transformo a double words

	; Lo shifteo a la izquierda 2 bytes
	psrldq xmm1, 2
	movdqa xmm0, xmm1

	punpcklwd xmm1, xmm8
	
	; Multiplico
	pmullw xmm1, xmm6
	paddd xmm14, xmm1
	; Recupero el valor inicial de xmm1
	movdqa xmm1, xmm0

	; Me quedo con la parte alta de xmm1, y lo transformo a double word
	punpckhwd xmm1, xmm8

	pmullw xmm1, xmm7
	paddd xmm14, xmm1
	; Vuelvo a recuperar el valor de xmm1
	movdqa xmm1, xmm0



; Me traigo 16 bytes de la fila i-1, empezando desde j-2 hasta j+14

	psrldq xmm2, 2
	movdqa xmm0, xmm2

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm2, xmm8
	
	; Multiplico
	pmullw xmm2, xmm9
	paddd xmm14, xmm2
	; Recupero el valor inicial de xmm1
	movdqa xmm2, xmm0

	; Me quedo con la parte alta de xmm2, y lo transformo a double word
	punpckhwd xmm2, xmm8
	
	pmullw xmm2, xmm10
	paddd xmm14, xmm2
	; Vuelvo a recuperar el valor de xmm2
	movdqa xmm2, xmm0

; Me traigo 16 bytes de la fila i, empezando desde j-2 hasta j+14
	
	psrldq xmm3, 2
	movdqa xmm0, xmm3

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm3, xmm8
	
	; Multiplico
	pmullw xmm3, xmm11
	paddd xmm14, xmm3
	; Recupero el valor inicial de xmm1
	movdqa xmm3, xmm0

	; Me quedo con la parte alta de xmm3, y lo transformo a double word
	punpckhwd xmm3, xmm8
	
	pmullw xmm3, xmm12
	paddd xmm14, xmm3
	; Vuelvo a recuperar el valor de xmm3
	movdqa xmm3, xmm0

; Me traigo 16 bytes de la fila i+1, empezando desde j-2 hasta j+14
	psrldq xmm4, 2
	movdqa xmm0, xmm4

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm4, xmm8
	
	; Multiplico
	pmullw xmm4, xmm9
	paddd xmm14, xmm4
	; Recupero el valor inicial de xmm1
	movdqa xmm4, xmm0

	; Me quedo con la parte alta de xmm4, y lo transformo a double word
	punpckhwd xmm4, xmm8
	
	pmullw xmm4, xmm10
	paddd xmm14, xmm4
	; Vuelvo a recuperar el valor de xmm4
	movdqa xmm4, xmm0

; Me traigo 16 bytes de la fila i+2, empezando desde j-2 hasta j+14
	psrldq xmm5, 2
	movdqa xmm0, xmm5

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm5, xmm8
	
	; Multiplico
	pmullw xmm5, xmm6
	paddd xmm14, xmm5
	; Recupero el valor inicial de xmm1
	movdqa xmm5, xmm0

	; Me quedo con la parte alta de xmm5, y lo transformo a double word
	punpckhwd xmm5, xmm8
	
	pmullw xmm5, xmm7
	paddd xmm14, xmm5
	; Vuelvo a recuperar el valor de xmm5
	movdqa xmm5, xmm0


	phaddd xmm14, xmm14
	; [0:31] = part_1 + part_2
	; [32:63] = part_3 + part_4

	phaddd xmm14, xmm14
	; [0:31] = part_1 + part_2 + part_3 + part_4


; Todo esto para calcular el kernel para 1 punto (i,j+2)

	movdqu xmm13, [mascara_tercer_elemento]
	pand xmm14, xmm13
;	pand xmm14, [mascara_tercer_elemento]

	paddd xmm15, xmm14



;; Intento procesar el punto (i, j+3)
	pxor xmm14, xmm14


	; Tomo los 4 bytes mas bajos, y los transformo a double words

	; Lo shifteo a la izquierda 2 bytes
	psrldq xmm1, 2
	movdqa xmm0, xmm1

	punpcklwd xmm1, xmm8
	
	; Multiplico
	pmullw xmm1, xmm6
	paddd xmm14, xmm1
	; Recupero el valor inicial de xmm1
	movdqa xmm1, xmm0

	; Me quedo con la parte alta de xmm1, y lo transformo a double word
	punpckhwd xmm1, xmm8
	
	pmullw xmm1, xmm7
	paddd xmm14, xmm1
	; Vuelvo a recuperar el valor de xmm1
	movdqa xmm1, xmm0



; Me traigo 16 bytes de la fila i-1, empezando desde j-2 hasta j+14

	psrldq xmm2, 2
	movdqa xmm0, xmm2

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm2, xmm8
	
	; Multiplico
	pmullw xmm2, xmm9
	paddd xmm14, xmm2
	; Recupero el valor inicial de xmm1
	movdqa xmm2, xmm0

	; Me quedo con la parte alta de xmm2, y lo transformo a double word
	punpckhwd xmm2, xmm8
	
	pmullw xmm2, xmm10
	paddd xmm14, xmm2
	; Vuelvo a recuperar el valor de xmm2
	movdqa xmm2, xmm0

; Me traigo 16 bytes de la fila i, empezando desde j-2 hasta j+14
	
	psrldq xmm3, 2
	movdqa xmm0, xmm3

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm3, xmm8
	
	; Multiplico
	pmullw xmm3, xmm11
	paddd xmm14, xmm3
	; Recupero el valor inicial de xmm1
	movdqa xmm3, xmm0

	; Me quedo con la parte alta de xmm3, y lo transformo a double word
	punpckhwd xmm3, xmm8
	
	pmullw xmm3, xmm12
	paddd xmm14, xmm3
	; Vuelvo a recuperar el valor de xmm3
	movdqa xmm3, xmm0

; Me traigo 16 bytes de la fila i+1, empezando desde j-2 hasta j+14
	psrldq xmm4, 2
	movdqa xmm0, xmm4

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm4, xmm8
	
	; Multiplico
	pmullw xmm4, xmm9
	paddd xmm14, xmm4
	; Recupero el valor inicial de xmm1
	movdqa xmm4, xmm0

	; Me quedo con la parte alta de xmm4, y lo transformo a double word
	punpckhwd xmm4, xmm8
	
	pmullw xmm4, xmm10
	paddd xmm14, xmm4
	; Vuelvo a recuperar el valor de xmm4
	movdqa xmm4, xmm0

; Me traigo 16 bytes de la fila i+2, empezando desde j-2 hasta j+14
	psrldq xmm5, 2
	movdqa xmm0, xmm5

	; Tomo los 4 bytes mas bajos, y los transformo a double words
	punpcklwd xmm5, xmm8
	
	; Multiplico
	pmullw xmm5, xmm6
	paddd xmm14, xmm5
	; Recupero el valor inicial de xmm1
	movdqa xmm5, xmm0

	; Me quedo con la parte alta de xmm5, y lo transformo a double word
	punpckhwd xmm5, xmm8
	
	pmullw xmm5, xmm7
	paddd xmm14, xmm5
	; Vuelvo a recuperar el valor de xmm5
	movdqa xmm5, xmm0


	phaddd xmm14, xmm14
	; [0:31] = part_1 + part_2
	; [32:63] = part_3 + part_4

	phaddd xmm14, xmm14
	; [0:31] = part_1 + part_2 + part_3 + part_4


; Todo esto para calcular el kernel para 1 punto (i,j+3)

	movdqu xmm13, [mascara_cuarto_elemento]
	pand xmm14, xmm13
;	pand xmm14, [mascara_cuarto_elemento]

	paddd xmm15, xmm14


; Ahora tengo que dividir por 159 cada valor
; Levanto los 4 valores de 159
	movdqu xmm13, [kernel_suma]

; Primero paso los ints a floating points single precision
	cvtdq2ps xmm13, xmm13
	cvtdq2ps xmm15, xmm15

; Ahora divido como si fueran floating points single precision
	divps xmm15, xmm13
; Y los vuelvo a convertir a ints de 32 bits
	cvtps2dq xmm15, xmm15

; Guardo el resultado

	xor rbx, rbx
	push r12

; Obtengo las 4 partes del xmm (que son de 32 bits) y las reajusto para ponerlas como 4 chars consecutivos (en un registro me alcanza)
	
	xor r12, r12
	movd r12d, xmm15
	add rbx, r12

	psrldq xmm15, 4
	xor r12, r12
	movd r12d, xmm15
	shl r12, 8
	add rbx, r12

	psrldq xmm15, 4
	xor r12, r12
	movd r12d, xmm15
	shl r12, 16
	add rbx, r12

	psrldq xmm15, 4
	xor r12, r12
	movd r12d, xmm15
	shl r12, 24
	add rbx, r12

	pop r12


	mov rax, r12
	mul r14

	; Sumo 4 veces el j para que se ajuste a los 4 bytes de la longitud del int
	add rax, r13
	add rax, r11

	mov [rax], ebx
	mov rax, rbx


fin_ruido:

	pop r15
	pop r14
	pop r13
	pop r12
	pop rbx
	
	add rsp, 24

	pop rbp

	ret




convolucion_suavizado_asm:

	push rbp		;A
	mov rbp, rsp
	sub rsp, 64		;A
	push rbx		;D
	push r12 		;A
	push r13 		;D
	push r14 		;A
	push r15 		;D

	; Idea de esta funcion. Iterar sobre el recorte y llamar a la funcion procesar_pixeles

	;input:
	;		- img src						-rdi
	;		- recorte* zonaAProcesar		-rsi
	;		- uchar* imgSuavizada			-rdx
	;		- int step			 			-rcx
	;		- int alto 						-r8


; Limpio los registros r12 a r15
	xor r12, r12
	xor r13, r13
	xor r14, r14
	xor r15, r15

; En los registros r12 a r15 levanto los valores de i1, i2, j1, j2 respectivamente
	mov r12d, [rsi]		; i1
	mov r13d, [rsi+4]	; i2
	mov r14d, [rsi+8]	; j1
	mov r15d, [rsi+12]	; j2

; En rsi guardo la referencia a la imagen de salida
	mov rsi, rdx

; Pongo los valores en los registros adecuados (para la llamada a la funcion procesar_pixeles)
; r9 = alto
	mov r9, r8
; r8 = step
	mov r8, rcx

	push r9	; A

; rbx = j1
	mov rbx, r14

loop_i:

; r14 = j1
	mov r14, rbx

loop_j:

; rdx = i
	mov rdx, r12
; rcx = j
	mov rcx, r14

	call procesar_pixeles

	pop r9	;D
	push r9	;A

	add r14, 4

	cmp r14, r15
	jge fin_loop_j

	jmp loop_j

fin_loop_j:

	inc r12
	cmp r12, r13
	jg fin_loop_i

	jmp loop_i

fin_loop_i:

	pop r9

	pop r15
	pop r14
	pop r13
	pop r12
	pop rbx
	
	add rsp, 64

	pop rbp
	ret


