#include <iostream>
#include "../funciones/funciones.hpp"

using namespace cv;

int main(int, char**){

  parameters params(0.3, 30, 25, 1, 1, 5, 30, 3, 8);

  VideoCapture capture(0);
  if (!capture.isOpened())
    throw exception();

  Mat fromWebcam;
  capture >> fromWebcam;

  namedWindow("Orga 2 TP Final");

  params.rows = fromWebcam.rows;
  params.cols = fromWebcam.cols;
  Mat canvas(fromWebcam.rows, params.cols + 700, CV_8UC3);
  pintar_uniforme(canvas,color(130,200,225), recorte(0,params.rows,params.cols,params.cols+700));
  pintar_uniforme(canvas,color(200,200,200), recorte(0,params.rows,0,params.cols));
  escribir(canvas, 50, params.cols+10, params.comandosInStr());
  escribir(canvas, 50, params.cols+330, params.parametrosInStr());
  imshow("Orga 2 TP Final", canvas);
  waitKey(10);

  while(!params.terminado) {
    pintar_uniforme(canvas,color(200,200,200), recorte(0,params.rows,0,params.cols));
    imshow("Orga 2 TP Final", canvas);
    waitKey(10);
    process_key(params, canvas);

    if (params.ajustar_bordes)
      ajustarBordes(params, canvas, capture);
    else if (params.ajustar_hough)
      ajustarHough(params, canvas, capture);
    else if (params.dibujar_trayectoria)
      pintarConHough(params, canvas, capture);
  }

  destroyWindow("Orga 2 TP Final");
  canvas.release();
  return 0;
}