#include <iostream>
#include <fstream>
#include <cassert>
#include <chrono>
#include <list>
#include <string>
#include "../codigo/funciones/funciones.hpp"

using namespace cv;

int main(int argc, char** argv){
  assert(argc >= 13);
  int iteraciones, i, j, cant_imagenes, umbral_borde, radio_min, cant_radios, radio_step, dist_max, cant_lej_max, cant_threads;
  double relacion_vot_rad;
  String dimension;
  chrono::milliseconds ms;
  Mat image;
  recorte zonaAProcesar;

  relacion_vot_rad = stod(argv[2]);
  umbral_borde = stoi(argv[3]);  
  radio_min = stoi(argv[4]);
  cant_radios = stoi(argv[5]);
  radio_step = stoi(argv[6]);
  dist_max = stoi(argv[7]);
  cant_lej_max = stoi(argv[8]);
  cant_threads = stoi(argv[9]);
  parameters params(relacion_vot_rad, umbral_borde, radio_min, cant_radios, radio_step, 5, dist_max, cant_lej_max, cant_threads);
  
  iteraciones = stoi(argv[10]);
  cant_imagenes = stoi(argv[11]);

  ofstream csv;
  csv.open (argv[12]);
  csv << "dimension,tiempo,algoritmo\n";

  for (j = 0; j < cant_imagenes; ++j) {
    dimension = to_string((j+1)*100) + "x" + to_string((j+1)*100);
    cout << "\t " + String(argv[1]) + dimension + ".png" << endl;
    
    image = imread(String(argv[1]) + dimension + ".png" , CV_LOAD_IMAGE_GRAYSCALE);
    
    for(i = 0; i < iteraciones; ++i) {
      
      // midiendo tiempos en cpp
      zonaAProcesar.i1 = 0;
      zonaAProcesar.i2 = image.rows;
      zonaAProcesar.j1 = 0;
      zonaAProcesar.j2 = image.cols;

      params.usar_asm = false;
      auto start = chrono::steady_clock::now();
      hough_circulos(&image, zonaAProcesar, params);
      ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);

      // Imprimiendo el resultado
      csv << dimension << "," << to_string(ms.count()) << "," << "c++" << "\n";   

      // Midiendo tiempo en asm
      zonaAProcesar.i1 = 0;
      zonaAProcesar.i2 = image.rows;
      zonaAProcesar.j1 = 0;
      zonaAProcesar.j2 = image.cols;

      params.usar_asm = true;
      start = chrono::steady_clock::now();
      hough_circulos(&image, zonaAProcesar, params);
      ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);
    
      // Imprimiendo el resultado
      csv << dimension << "," << to_string(ms.count()) << "," << "assembly" << "\n";
    }
  }

  return 0;
}