# -*- coding: utf-8 -*-
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
from math import floor
import sys


# reading csv file
df = pd.read_csv(sys.argv[1],sep=',',header=0)

#df_cpp = df[df.algoritmo == "c++"]
#df_asm = df[df.algoritmo == "assembly"]

cantidad_pixeles = []
for d in df.dimension:
	cantidad_pixeles.append(int(d.split("x")[0])*int(d.split("x")[1]))
df['cantidad_pixeles'] = cantidad_pixeles

#cantidad_pixeles = []
#for d in df_asm.dimension:
#	cantidad_pixeles.append(int(d.split("x")[0])*int(d.split("x")[1]))
#
#df_asm['cantidad_pixeles'] = cantidad_pixeles

# ploting the mean of the trial reaction times separated by plane color (yellow, red)
ax = sns.lmplot(x="cantidad_pixeles", y="tiempo", x_estimator=np.mean, data=df, hue="algoritmo", legend_out=False)

# setting plot attributes
ax.set_axis_labels("cantidad de pixeles", "Tiempo de procesamiento en milisegundos")

plt.show()