# -*- coding: utf-8 -*-
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
from math import floor
import sys

# reading csv file
df = pd.read_csv(sys.argv[1],sep=',',header=0)

cpp_df = df[df['algoritmo'] == 'c++']
asm_df = df[df['algoritmo'] == 'assembly']

rayas_cpp = []
promedios_cpp = []
for u,m in cpp_df.groupby(['rayas'])['tiempo'].mean().iteritems():
	rayas_cpp.append(u)
	promedios_cpp.append(m)

rayas_asm = []
promedios_asm = []
for u,m in asm_df.groupby(['rayas'])['tiempo'].mean().iteritems():
	rayas_asm.append(u)
	promedios_asm.append(m)

# ploting the mean of the trial reaction times separated by plane color (yellow, red)
sns.set_style("darkgrid")
cpp_plt, = plt.plot(rayas_cpp, promedios_cpp, label="c++")
asm_plt, = plt.plot(rayas_asm, promedios_asm, label="assebly")

first_legend = plt.legend(handles=[cpp_plt, asm_plt], loc=1)

plt.ylabel('Tiempo en milisegundos')
plt.xlabel('Cantidad de rayas')
plt.show()

plt.show()