# -*- coding: utf-8 -*-
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
from math import floor
import sys


# reading csv file
df = pd.read_csv(sys.argv[1],sep=',',header=0)

# ploting the mean of the trial reaction times separated by plane color (yellow, red)
ax = sns.barplot(x="threads", y="tiempo", hue="algoritmo", data=df)

# setting plot attributes
ax.set_ylabel("Tiempo de procesamiento en milisegundos")
ax.set_xlabel("Cantidad de threads")
for p in ax.patches:
    height = p.get_height()
    ax.text(p.get_x() + p.get_width()/2 - 0.07, height + 5, '%s'%((str(floor(height))).replace('.0', '', 1)))

plt.show()