#include <iostream>
#include <fstream>
#include <cassert>
#include <chrono>
#include <list>
#include <string>
#include "../codigo/funciones/funciones.hpp"

using namespace cv;

int main(int argc, char** argv){
  assert(argc >= 12);
  int j, cant_imagenes, umbral_borde, radio_min, cant_radios, radio_step, dist_max, cant_lej_max, cant_threads;
  double relacion_vot_rad;
  Mat image,colorImage;
  circulo actual;
  recorte zonaAProcesar;
  vector<Vec3f> circles;

  relacion_vot_rad = stod(argv[2]);
  umbral_borde = stoi(argv[3]);  
  radio_min = stoi(argv[4]);
  cant_radios = stoi(argv[5]);
  radio_step = stoi(argv[6]);
  dist_max = stoi(argv[7]);
  cant_lej_max = stoi(argv[8]);
  cant_threads = stoi(argv[9]);
  parameters params(relacion_vot_rad, umbral_borde, radio_min, cant_radios, radio_step, 5, dist_max, cant_lej_max, cant_threads);
  
  cant_imagenes = stoi(argv[10]);

  for (j = 0; j < cant_imagenes; ++j) {
    cout << String(argv[1]) << to_string(j) + ".png" << endl;
    
    // midiendo robustes en cpp
    colorImage = imread(String(argv[1]) + to_string(j) + ".png" , CV_LOAD_IMAGE_COLOR);
    cvtColor(colorImage,image,COLOR_BGR2GRAY);

    zonaAProcesar.i1 = 0;
    zonaAProcesar.i2 = image.rows;
    zonaAProcesar.j1 = 0;
    zonaAProcesar.j2 = image.cols;

    params.usar_asm = false;
    actual = hough_circulos(&image, zonaAProcesar, params);

    if (actual.valido)
      circle(colorImage, Point(actual.x, actual.y), actual.radio, CV_RGB(0,0,0), -1, 8);
    imwrite(String(argv[11]) + to_string(j) + "-cpp.jpg", colorImage);

    // midiendo robustes en asm
    colorImage = imread(String(argv[1]) + to_string(j) + ".png" , CV_LOAD_IMAGE_COLOR);
    cvtColor(colorImage,image,COLOR_BGR2GRAY);

    zonaAProcesar.i1 = 0;
    zonaAProcesar.i2 = image.rows;
    zonaAProcesar.j1 = 0;
    zonaAProcesar.j2 = image.cols;

    params.usar_asm = true;
    hough_circulos(&image, zonaAProcesar, params);

    if (actual.valido)
      circle(colorImage, Point(actual.x, actual.y), actual.radio, CV_RGB(0,0,0), -1, 8);
    imwrite(String(argv[11]) + to_string(j) + "-asm.jpg", colorImage);

    // midiendo robustes en openCV-2.4.9
    colorImage = imread(String(argv[1]) + to_string(j) + ".png" , CV_LOAD_IMAGE_COLOR);
    cvtColor(colorImage,image,COLOR_BGR2GRAY);
    GaussianBlur( image, image, Size(9, 9), 2, 2 );
    HoughCircles( image, circles, CV_HOUGH_GRADIENT, 1, image.rows/8, 200, relacion_vot_rad*100, 100, 100 );

    if (circles.size() > 0) {
      Point centro(cvRound(circles[0][0]), cvRound(circles[0][1]));
      int radio = cvRound(circles[0][2]);
      circle(colorImage, centro, radio, CV_RGB(0,0,0), -1, 8);
    }
    imwrite(String(argv[11]) + to_string(j) + "-openCV-2-4-9.jpg", colorImage);

  }

  return 0;
}