#include <iostream>
#include <fstream>
#include <cassert>
#include <chrono>
#include <list>
#include <string>
#include "../codigo/funciones/funciones.hpp"

using namespace cv;

int main(int argc, char** argv){
  assert(argc >= 12);
  int iteraciones, i, j, l, cant_rayas, umbral_borde, radio_min, cant_radios, radio_step, dist_max, cant_lej_max, cant_threads;
  double relacion_vot_rad;
  chrono::milliseconds ms;
  recorte zonaAProcesar;

  relacion_vot_rad = stod(argv[2]);
  umbral_borde = stoi(argv[3]);  
  radio_min = stoi(argv[4]);
  cant_radios = stoi(argv[5]);
  radio_step = stoi(argv[6]);
  dist_max = stoi(argv[7]);
  cant_lej_max = stoi(argv[8]);
  cant_threads = stoi(argv[9]);
  parameters params(relacion_vot_rad, umbral_borde, radio_min, cant_radios, radio_step, 5, dist_max, cant_lej_max, cant_threads);
  
  iteraciones = stoi(argv[10]);


  ofstream csv;
  csv.open (argv[11]);
  csv << "rayas,tiempo,algoritmo\n";

  Mat image(600,600,CV_8UC3);
  cant_rayas = 0;
  for (j = 5; j < 600; j += 10) {
    cout << "linea: " << j << endl;

    for(i = 5; i < 600; i += 5) {
      line(image, Point(j, i), Point(j,i+2), CV_RGB(255,255,255), 1, 1);
      imwrite(argv[1] + to_string(cant_rayas) + ".jpg", image);
      ++cant_rayas;

      for(l = 0; l < iteraciones; ++l) {   
        
        
        // midiendo tiempos en cpp
        zonaAProcesar.i1 = 0;
        zonaAProcesar.i2 = image.rows;
        zonaAProcesar.j1 = 0;
        zonaAProcesar.j2 = image.cols;

        params.usar_asm = false;
        auto start = chrono::steady_clock::now();
        hough_circulos(&image, zonaAProcesar, params);
        ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);

        // imprimiendo el resultado
        csv << to_string(cant_rayas) << "," << to_string(ms.count()) << "," << "c++" << "\n";

        // midiendo tiempo en asm
        zonaAProcesar.i1 = 0;
        zonaAProcesar.i2 = image.rows;
        zonaAProcesar.j1 = 0;
        zonaAProcesar.j2 = image.cols;

        params.usar_asm = true;
        start = chrono::steady_clock::now();
        hough_circulos(&image, zonaAProcesar, params);
        ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);
      
        // imprimiendo el resultado
        csv << to_string(cant_rayas) << "," << to_string(ms.count()) << "," << "assembly" << "\n";
      }
    }
  }

  return 0;
}