#include <iostream>
#include <fstream>
#include <cassert>
#include <chrono>
#include <list>
#include <string>
#include "../codigo/funciones/funciones.hpp"

using namespace cv;

int main(int argc, char** argv){
  assert( argc >= 13);
  int iteraciones, i, j, cant_threads, umbral_borde, radio_min, cant_radios, radio_step, dist_max, cant_lej_max, min_threads;
  double relacion_vot_rad;
  chrono::milliseconds ms;
  vector<Vec3f> circles;
  recorte zonaAProcesar;
  Mat image;

  relacion_vot_rad = stod(argv[2]);
  umbral_borde = stoi(argv[3]);  
  radio_min = stoi(argv[4]);
  cant_radios = stoi(argv[5]);
  radio_step = stoi(argv[6]);
  dist_max = stoi(argv[7]);
  cant_lej_max = stoi(argv[8]);
  min_threads = stoi(argv[9]);
  parameters params(relacion_vot_rad, umbral_borde, radio_min, cant_radios, radio_step, 5, dist_max, cant_lej_max, min_threads-1);
  
  iteraciones = stoi(argv[10]);
  cant_threads = stoi(argv[11]);

  ofstream csv;
  csv.open (argv[12]);
  csv << "threads,tiempo,algoritmo\n";
  
  for (j = 0; j < cant_threads; ++j) {
    ++params.cantidad_threads;
    cout << "cantidad de threads: " << (params.cantidad_threads*params.cantidad_threads) << endl;
    image = imread(argv[1], CV_LOAD_IMAGE_GRAYSCALE);

    for(i = 0; i < iteraciones; ++i) {
    
      // midiendo tiempos en cpp
      zonaAProcesar.i1 = 0;
      zonaAProcesar.i2 = image.rows;
      zonaAProcesar.j1 = 0;
      zonaAProcesar.j2 = image.cols;

      params.usar_asm = false;
      auto start = chrono::steady_clock::now();
      hough_circulos(&image, zonaAProcesar, params);
      ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);

      // Imprimiendo el resultado
      csv << to_string(params.cantidad_threads) << "," << to_string(ms.count()) << "," << "c++" << "\n";   

      // Midiendo tiempo en asm
      zonaAProcesar.i1 = 0;
      zonaAProcesar.i2 = image.rows;
      zonaAProcesar.j1 = 0;
      zonaAProcesar.j2 = image.cols;

      params.usar_asm = true;
      start = chrono::steady_clock::now();
      hough_circulos(&image, zonaAProcesar, params);
      ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);
    
      // Imprimiendo el resultado
      csv << to_string(params.cantidad_threads) << "," << to_string(ms.count()) << "," << "assembly" << "\n";
    }
  }

  return 0;
}