#include <iostream>
#include <fstream>
#include <cassert>
#include <chrono>
#include <list>
#include <string>
#include "../codigo/funciones/funciones.hpp"

using namespace cv;

int main(int argc, char** argv){
  assert(argc >= 13);
  int iteraciones, i, j, umbral_step, cant_umbrales, min_umbral_borde, radio_min, cant_radios, radio_step, dist_max, cant_lej_max, cant_threads;
  double relacion_vot_rad;
  String dimension;
  chrono::milliseconds ms;
  Mat image;
  recorte zonaAProcesar;

  relacion_vot_rad = stod(argv[2]);
  min_umbral_borde = stoi(argv[3]);  
  radio_min = stoi(argv[4]);
  cant_radios = stoi(argv[5]);
  radio_step = stoi(argv[6]);
  dist_max = stoi(argv[7]);
  cant_lej_max = stoi(argv[8]);
  cant_threads = stoi(argv[9]);
  umbral_step = stoi(argv[12]);
  parameters params(relacion_vot_rad, min_umbral_borde - umbral_step, radio_min, cant_radios, radio_step, 5, dist_max, cant_lej_max, cant_threads);
  
  iteraciones = stoi(argv[10]);
  cant_umbrales = stoi(argv[11]);

  ofstream csv;
  csv.open (argv[13]);
  csv << "umbral,tiempo,algoritmo\n";
  
  image = imread(argv[1] , CV_LOAD_IMAGE_GRAYSCALE);

  for (j = 0; j < cant_umbrales; ++j) {
    params.umbral_bordes += umbral_step;
    cout << params.umbral_bordes << endl;
    
    for(i = 0; i < iteraciones; ++i) {  

      // Midiendo tiempo en asm
      zonaAProcesar.i1 = 0;
      zonaAProcesar.i2 = image.rows;
      zonaAProcesar.j1 = 0;
      zonaAProcesar.j2 = image.cols;

      params.usar_asm = true;
      auto start = chrono::steady_clock::now();
      hough_circulos(&image, zonaAProcesar, params);
      ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);
    
      // Imprimiendo el resultado
      csv << params.umbral_bordes << "," << to_string(ms.count()) << "," << "assembly" << "\n";

      // midiendo tiempos en cpp
      zonaAProcesar.i1 = 0;
      zonaAProcesar.i2 = image.rows;
      zonaAProcesar.j1 = 0;
      zonaAProcesar.j2 = image.cols;

      params.usar_asm = false;
      start = chrono::steady_clock::now();
      hough_circulos(&image, zonaAProcesar, params);
      ms = chrono::duration_cast<chrono::milliseconds>(chrono::steady_clock::now()-start);

      // Imprimiendo el resultado
      csv << params.umbral_bordes << "," << to_string(ms.count()) << "," << "c++" << "\n"; 
    }
  }

  return 0;
}